// CodaMsgList.cpp : implementation file
//

#include "stdafx.h"
#include "CodaStart.h"
#include "CodaLSock.h"
#include "CodaMsgList.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCodaMsgList

CCodaMsgList::CCodaMsgList()
{
	// Get imagelist
	m_imageList.Create (IDR_CODAMSGIMGS, 12, 1, CLR_NONE);
}

CCodaMsgList::~CCodaMsgList()
{
}


BEGIN_MESSAGE_MAP(CCodaMsgList, CListCtrl)
	//{{AFX_MSG_MAP(CCodaMsgList)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCodaMsgList message handlers

BOOL CCodaMsgList::Attach(CListCtrl* pList)
{
	// Get a socket
	if (!m_sock.Create (this)) {
		AfxMessageBox(IDP_SOCKET_CREATE_FAILED);
		return FALSE;
	}

	if (!CWnd::Attach(pList->m_hWnd))
		return FALSE;

	SetImageList (&m_imageList, LVSIL_SMALL);

	InsertColumn (0, "Opcode", LVCFMT_LEFT, 100);
	InsertColumn (1, "Unique", LVCFMT_RIGHT, 50);
	InsertColumn (2, "VFid", LVCFMT_LEFT, 108);
	InsertColumn (3, "Other information", LVCFMT_LEFT, 220);
	InsertColumn (4, "Number", LVCFMT_RIGHT, 50);

	ModifyStyle (LVS_TYPEMASK, LVS_REPORT);

	m_cMsgs = 0;
	return TRUE;
}

void CCodaMsgList::SetListen (BOOL b)
{
	m_bListening = b;
}

void CCodaMsgList::Reset ()
{
	DeleteAllItems();
	m_cMsgs = 0;
}

PTCHAR CCodaMsgList::getString (struct stringList *sl, DWORD dw, PTCHAR szTblName) 
{
	static TCHAR szBuf[100];
	while (sl && sl->sl_szName) {
		if (dw == sl->sl_dwValue)
			return sl->sl_szName;
		sl++;
	}

	_stprintf (szBuf, _TEXT("%s #%d"), szTblName, dw);
	return szBuf;
}


#define KERNEL
#include "coda.h"


CString printVFid(ViceFid *vfid)
{
  CString str;
  str.Format("%lx,%ld,%ld", vfid->Volume, vfid->Vnode, vfid->Unique);
  return str;
}

CString printAttr(struct coda_vattr *p)
{
  CString str;
  str.Format("mode %x nlink %d uid %d gid %d size %ld ",
	  p->va_mode, p->va_nlink, p->va_uid, p->va_gid,
	  p->va_size);
  return str;
}


// Add a received message to the list box

void CCodaMsgList::addCodaRequest (PCHAR p, DWORD cb)
{
	union inputArgs *in = (union inputArgs *) p;
	CString str, str2, strvfid;

	if (!m_bListening)
		return;

	InsertItem (m_cMsgs, getString(m_slOpcode, in->ih.opcode, _TEXT("opcode")), 0);

	str.Format(_TEXT("%d"), in->ih.unique);
	SetItemText (m_cMsgs, 1, str);

	str.Format(_TEXT("%d"), m_cMsgs);
	SetItemText (m_cMsgs, 4, str);

	str = _TEXT("");
	switch (in->ih.opcode) {
	case CODA_OPEN:
		strvfid = printVFid (&in->coda_open.VFid);
        str2.Format(_TEXT("flags %d "), in->coda_open.flags);
		str += str2;
	    break;
	case CODA_LOOKUP:
		strvfid = printVFid (&in->coda_lookup.VFid);
		str += _TEXT("\"");
		str += (PCHAR) (p + (int) in->coda_lookup.name);
		str += _TEXT("\"");
	    break;
	case CODA_CREATE:
		strvfid = printVFid (&in->coda_create.VFid);
		str += _TEXT("\"");
		str += (PCHAR) (p + (int) in->coda_create.name);
		str += _TEXT("\" ");
        str2.Format(_TEXT("mode %d"), in->coda_create.mode);
		str += str2;
		break;
	case CODA_CLOSE:
		strvfid = printVFid (&in->coda_close.VFid);
		str2.Format(_TEXT("flags %d "), in->coda_close.flags);
		str += str2;
		break;
	case CODA_GETATTR:
		strvfid = printVFid (&in->coda_getattr.VFid);
		break;
	case CODA_SETATTR:
		strvfid = printVFid (&in->coda_setattr.VFid);
		str += printAttr(&in->coda_setattr.attr);
		break;
	case CODA_IOCTL:
		strvfid = printVFid (&in->coda_ioctl.VFid);
		str2.Format (_TEXT("code %d"), in->coda_ioctl.cmd);
		str += str2;
		break;
	}

	SetItemText(m_cMsgs, 2, strvfid);
	SetItemText(m_cMsgs, 3, str);

	EnsureVisible (m_cMsgs, TRUE);

	m_cMsgs++;
}

void CCodaMsgList::addCodaReply (PCHAR p, DWORD cb)
{
	union outputArgs *out = (union outputArgs *) p;
	CString str, str2, strvfid;

	if (!m_bListening)
		return;

    if (out->oh.opcode >= CODA_REPLACE && out->oh.opcode <= CODA_PURGEFID) {
		// downcall from Venus to MiniCache

		InsertItem(m_cMsgs, getString(m_slOpcode, out->oh.opcode, _TEXT("opcode")), 1);
		SetItemText(m_cMsgs, 1, _TEXT("(DOWNCALL)"));

		strvfid = "";
		switch (out->oh.opcode) {
		case CODA_ZAPFILE:
			strvfid = printVFid(&out->coda_zapfile.CodaFid);
			break;
		case CODA_ZAPDIR:
			strvfid = printVFid(&out->coda_zapdir.CodaFid);
			break;
		case CODA_FLUSH:
			break;
		case CODA_REPLACE:
			strvfid = printVFid(&out->coda_replace.OldFid);
			break;
		case CODA_PURGEUSER:
			break;
		case CODA_PURGEFID:
			strvfid = printVFid(&out->coda_purgefid.CodaFid);
			break;
		}
		SetItemText(m_cMsgs, 2, strvfid);
	} else if (out->oh.opcode >= 99) {
		// administrative message to relay process
		InsertItem(m_cMsgs, getString(m_slOpcode, out->oh.opcode, _TEXT("opcode")), 3);
	} else {
		if (out->oh.result) {
			// error reply to minicache request
			InsertItem(m_cMsgs, getString(m_slOpcode, out->oh.opcode, _TEXT("opcode")), 2);

			str.Format (_TEXT("%d"), out->oh.unique);
			SetItemText(m_cMsgs, 1, str);

			str = getString(m_slErrno, out->oh.result, _TEXT("errno"));
			SetItemText(m_cMsgs, 3, str);
		} else {
			// success reply to minicache request
			InsertItem(m_cMsgs, getString(m_slOpcode, out->oh.opcode, _TEXT("opcode")), 1);

			str.Format (_TEXT("%d"), out->oh.unique);
			SetItemText(m_cMsgs, 1, str);

			str = "";

			switch (out->oh.opcode) {
			case CODA_ROOT:
				strvfid = printVFid(&out->coda_root.VFid);
				break;

			case CODA_GETATTR:
				str += printAttr(&out->coda_getattr.attr);
				break;
			  
			case CODA_LOOKUP:
				strvfid = printVFid(&out->coda_lookup.VFid);
				str2.Format(_TEXT("type %d"), out->coda_lookup.vtype);
				str += str2;
				break;

			case CODA_OPEN:
				str2.Format(_TEXT("dev %d inode %d"), out->coda_open.dev, 
				  out->coda_open.inode);
				str += str2;
				break;

			case CODA_CREATE:
				strvfid = printVFid(&out->coda_create.VFid);
				str += printAttr(&out->coda_create.attr);
				break;

			case CODA_IOCTL:
				str2.Format(_TEXT("len %d data %d: %x %x"), out->coda_ioctl.len,
					out->coda_ioctl.data,
					(DWORD) *(PDWORD) (((PCHAR) out) + (DWORD) out->coda_ioctl.data),
					(DWORD) *(PDWORD) (((PCHAR) out) + (DWORD) out->coda_ioctl.data + sizeof(DWORD)));
				str += str2;
				break;
			}
			SetItemText(m_cMsgs, 2, strvfid);
			SetItemText(m_cMsgs, 3, str);
		}
	}

	str.Format(_TEXT("%d"), m_cMsgs);
	SetItemText (m_cMsgs, 4, str);

	EnsureVisible (m_cMsgs, TRUE);

	m_cMsgs++;
}

void CCodaMsgList::addOtherMsg(PCHAR p, DWORD cb)
{
	CString str;

	if (!m_bListening)
		return;

	InsertItem(m_cMsgs, _TEXT("Huh?"), 4);

	str.Format (_TEXT("len %d"), cb);
	SetItemText(m_cMsgs, 3, str);

	str.Format(_TEXT("%d"), m_cMsgs);
	SetItemText (m_cMsgs, 4, str);

	EnsureVisible (m_cMsgs, TRUE);

	m_cMsgs++;
}

#define EDOM		1
#define ERANGE		2
#define E2BIG		3
#define EACCES		4
#define EAGAIN		5
#define EBADF		6
#define EBUSY		7
#define ECHILD		8
#define EDEADLK		9
#define EEXIST		10
#define EFAULT		11
#define EFBIG		12
#define EINTR		13
#define EINVAL		14
#define EIO		15
#define EISDIR		16
#define EMFILE		17
#define EMLINK		18
#define ENAMETOOLONG	19
#define ENFILE		20
#define ENODEV		21
#define ENOENT		22
#define ENOEXEC		23
#define ENOLCK		24
#define ENOMEM		25
#define ENOSPC		26
#define ENOSYS		27
#define ENOTDIR		28
#define ENOTEMPTY	29
#define ENOTTY		30
#define ENXIO		31
#define EPERM		32
#define EPIPE		33
#define EROFS		34
#define ESPIPE		35
#define ESRCH		36
#define EXDEV		37
#define ENMFILE		38
#define EADDRINUSE        1000 /* XXX */
#define EACCESS           1001
#define EPROTONOSUPPORT   1002
#define EWOULDBLOCK       1003
#define ENOTCONN          1004
#define ETIMEDOUT         1005
#define EOPNOTSUPP        1006
#define EDQUOT            1007
#define EALREADY          1008
#define ENOBUFS           1009
#define ETOOMANYREFS      1010
#define ELOOP             1011
#define ESHUTDOWN         1012
#define ETXTBSY           1013

struct CCodaMsgList::stringList CCodaMsgList::m_slOpcode[] = {
  {CODA_ROOT, "CODA_ROOT"},
  {CODA_SYNC, "CODA_SYNC"},
  {CODA_OPEN, "CODA_OPEN"},
  {CODA_CLOSE, "CODA_CLOSE"},
  {CODA_IOCTL, "CODA_IOCTL"},
  {CODA_GETATTR, "CODA_GETATTR"},
  {CODA_SETATTR, "CODA_SETATTR"},
  {CODA_ACCESS, "CODA_ACCESS"},
  {CODA_LOOKUP, "CODA_LOOKUP"},
  {CODA_CREATE, "CODA_CREATE"},
  {CODA_REMOVE, "CODA_REMOVE"},
  {CODA_LINK, "CODA_LINK"},
  {CODA_RENAME, "CODA_RENAME"},
  {CODA_MKDIR, "CODA_MKDIR"},
  {CODA_RMDIR, "CODA_RMDIR"},
  {CODA_READDIR, "CODA_READDIR"},
  {CODA_SYMLINK, "CODA_SYMLINK"},
  {CODA_READLINK, "CODA_READLINK"},
  {CODA_FSYNC, "CODA_FSYNC"},
  {CODA_INACTIVE, "CODA_INACTIVE"},
  {CODA_VGET, "CODA_VGET"},
  {CODA_SIGNAL, "CODA_SIGNAL"},
  {CODA_REPLACE, "CODA_REPLACE"},
  {CODA_FLUSH, "CODA_FLUSH"},
  {CODA_PURGEUSER, "CODA_PURGEUSER"},
  {CODA_ZAPFILE, "CODA_ZAPFILE"},
  {CODA_ZAPDIR, "CODA_ZAPDIR"},
  {CODA_PURGEFID, "CODA_PURGEFID"},
  {CODA_OPEN_BY_PATH, "CODA_OPEN_BY_PATH"},
  {CODA_RESOLVE, "CODA_RESOLVE"},
  {CODA_REINTEGRATE, "CODA_REINTEGRATE"},
  {CODA_NCALLS, "CODA_NCALLS"},
  {99, "<<STOP>>"},
  {100, "<<START>>"},
  {0, NULL}
};


struct CCodaMsgList::stringList CCodaMsgList::m_slErrno[] = {
   {EDOM, "EDOM"},
   {ERANGE, "ERANGE"},
   {E2BIG, "E2BIG"},
   {EACCES, "EACCES"},
   {EAGAIN, "EAGAIN"},
   {EBADF, "EBADF"},
   {EBUSY, "EBUSY"},
   {ECHILD, "ECHILD"},
   {EDEADLK, "EDEADLK"},
   {EEXIST, "EEXIST"},
   {EFAULT, "EFAULT"},
   {EFBIG, "EFBIG"},
   {EINTR, "EINTR"},
   {EINVAL, "EINVAL"},
   {EIO, "EIO"},
   {EISDIR, "EISDIR"},
   {EMFILE, "EMFILE"},
   {EMLINK, "EMLINK"},
   {ENAMETOOLONG, "ENAMETOOLONG"},
   {ENFILE, "ENFILE"},
   {ENODEV, "ENODEV"},
   {ENOENT, "ENOENT"},
   {ENOEXEC, "ENOEXEC"},
   {ENOLCK, "ENOLCK"},
   {ENOMEM, "ENOMEM"},
   {ENOSPC, "ENOSPC"},
   {ENOSYS, "ENOSYS"},
   {ENOTDIR, "ENOTDIR"},
   {ENOTEMPTY, "ENOTEMPTY"},
   {ENOTTY, "ENOTTY"},
   {ENXIO, "ENXIO"},
   {EPERM, "EPERM"},
   {EPIPE, "EPIPE"},
   {EROFS, "EROFS"},
   {ESPIPE, "ESPIPE"},
   {ESRCH, "ESRCH"},
   {EXDEV, "EXDEV"},
   {ENMFILE, "ENMFILE"},
   {EADDRINUSE, "EADDRINUSE"},
   {EACCESS, "EACCESS"},
   {EPROTONOSUPPORT, "EPROTONOSUPPORT"},
   {EWOULDBLOCK, "EWOULDBLOCK"},
   {ENOTCONN, "ENOTCONN"},
   {ETIMEDOUT, "ETIMEDOUT"},
   {EOPNOTSUPP, "EOPNOTSUPP"},
   {EDQUOT, "EDQUOT"},
   {EALREADY, "EALREADY"},
   {ENOBUFS, "ENOBUFS"},
   {ETOOMANYREFS, "ETOOMANYREFS"},
   {ELOOP, "ELOOP"},
   {ESHUTDOWN, "ESHUTDOWN"},
   {ETXTBSY, "ETXTBSY"},
   {0, NULL}
};
