
#include "stdafx.h"
#include "ProcWatch.h"
#include "resource.h"

CProcessWatcher::CProcessWatcher (PTCHAR szName, CWnd *pWnd, int nID)
{
	m_szProcessName = szName;
	m_pWnd = pWnd;
	m_nID = nID;
	m_state = UNKNOWN;
	m_bExpected = FALSE;
}

void CProcessWatcher::SetName (PTCHAR p)
{
	m_szProcessName = strlwr(p);
}

void CProcessWatcher::SetExpectation (BOOL b)
{
	m_bExpected = b;
}

void CProcessWatcher::Update ()
{
	enum states oldstate = m_state;

	m_bPresent = FALSE;

	if (!EnumWindows (CProcessWatcher::EnumCallback,
					  (LPARAM) this)) {
		m_pWnd->SetDlgItemText(m_nID, _TEXT("Error in EnumWindows!"));
		return;
	}

	if (m_bPresent) {
		m_state = RUNNING;
	} else if (m_bExpected) {
		switch (oldstate) {
		case UNKNOWN:
		case NOTYET:
			m_state = WAITING;
			break;

		case RUNNING:
			m_state = CRASHED;
		}
	} else {
		switch (oldstate) {
		case UNKNOWN:
			m_state = NOTYET;
			break;

		case WAITING:
			m_state = NOTYET;
			break;

		case RUNNING:
		case CRASHED:
			m_state = GONE;
		}
	}

	if (oldstate == m_state)
		return;

	switch (m_state) {
	case UNKNOWN:
		m_pWnd->SetDlgItemText(m_nID, _TEXT("Unknown"));
		break;

	case NOTYET:
		m_pWnd->SetDlgItemText(m_nID, _TEXT("Not started"));
		break;

	case WAITING:
		m_pWnd->SetDlgItemText(m_nID, _TEXT("Should be starting"));
		break;

	case RUNNING:
		m_pWnd->SetDlgItemText(m_nID, _TEXT("Running"));
		break;

	case GONE:
		m_pWnd->SetDlgItemText(m_nID, _TEXT("Stopped"));
		break;

	case CRASHED:
		m_pWnd->SetDlgItemText(m_nID, _TEXT("CRASHED!"));
		break;
	} 
}

BOOL __stdcall CProcessWatcher::EnumCallback (HWND hWnd, LPARAM lParam)
{
	CProcessWatcher* pPw = (CProcessWatcher*) lParam;
	TCHAR szTitle[100];

	if (GetWindowText (hWnd, szTitle, sizeof(szTitle)) == 0)
		return TRUE;

	if (strstr (strlwr(szTitle), pPw->m_szProcessName))
		pPw->m_bPresent = TRUE;

	return TRUE;
}
